/**
 * @author LaCible / http://la.cible.free.fr/
 */

function BinaryStream(data)
{	
	/**
	 * privates members
	 */
	var byteArray = new Uint8Array(data);
	var sbyteArray = new Int8Array(data);
	
	/**
	 * public properties
	 */
	this.length = data.byteLength;
	this.position = 0;
	
	/**
	 * public methodes
	 */
	this.skip = function(nbytes)
	{
		this.position += nbytes;
	};
	this.writeString = function(txt)
	{
		for(var c=0;c<txt.length;c++)
			byteArray[this.position+c] = txt.charCodeAt(c);
		this.position+=txt.length;
	};
	
	this.readString = function(length)
	{
		var text = "";
		for ( var c = 0; c < length; c++ ) 
			text += String.fromCharCode( byteArray[ this.position+c ] );
		this.position+=length;
		return text;
	};
	
	this.readZeroTerminatedString = function(length)
	{
		var text = "";
		for ( var c = 0; c < length; c++ ) 
		{
			if(byteArray[ this.position+c ] == 0)
				break;
			text += String.fromCharCode( byteArray[ this.position+c ] );
		}
		this.position+=length;
		return text;
	};
	
	this.writeInt8 = function(val)
	{
		sbyteArray[this.position++] = val; 
	};
	
	this.readInt8 = function()
	{
		return sbyteArray[this.position++]; 
	};
	
	this.writeUInt8 = function(val)
	{
		byteArray[this.position++] = val; 
	};
	
	this.readUInt8 = function()
	{
		return byteArray[this.position++]; 
	};
	
	this.writeInt16 = function(val)
	{
		var buffer = new ArrayBuffer(Int16Array.BYTES_PER_ELEMENT); 
		var write = new Int16Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readInt16 = function()
	{
		var read;
		if(this.position%Int16Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Int16Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Int16Array(buffer);
		}
		else
		{
			read = new Int16Array( data, this.position, 1 );
			this.position+=Int16Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
	this.writeUInt16 = function(val)
	{
		var buffer = new ArrayBuffer(Uint16Array.BYTES_PER_ELEMENT); 
		var write = new Uint16Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readUInt16 = function()
	{
		var read;
		if(this.position%Uint16Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Uint16Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Uint16Array(buffer);
		}
		else
		{
			read = new Uint16Array( data, this.position, 1 );
			this.position+=Uint16Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
	this.writeInt32 = function(val)
	{
		var buffer = new ArrayBuffer(Int32Array.BYTES_PER_ELEMENT); 
		var write = new Int32Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readInt32 = function()
	{
		var read;
		if(this.position%Int32Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Int32Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Int32Array(buffer);
		}
		else
		{
			read = new Int32Array( data, this.position, 1 );
			this.position+= Int32Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
	this.writeUInt32 = function(val)
	{
		var buffer = new ArrayBuffer(Uint32Array.BYTES_PER_ELEMENT); 
		var write = new Uint32Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readUInt32 = function()
	{
		var read;
		if(this.position%Uint32Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Uint32Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Uint32Array(buffer);
		}
		else
		{
			read = new Uint32Array( data, this.position, 1 );
			this.position+= Uint32Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
	this.writeSingle = function(val)
	{
		var buffer = new ArrayBuffer(Float32Array.BYTES_PER_ELEMENT); 
		var write = new Float32Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readSingle = function()
	{
		var read;
		if(this.position%Float32Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Float32Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Float32Array(buffer);
		}
		else
		{
			read = new Float32Array( data, this.position, 1 );
			this.position+= Float32Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
	this.writeDouble = function(val)
	{
		var buffer = new ArrayBuffer(Float64Array.BYTES_PER_ELEMENT); 
		var write = new Float64Array(buffer);
		var read = new Uint8Array(buffer);
		write[0] = val;
		for(var i=0;i<read.length;i++)
			this.writeUInt8(read[i])
	};
	
	this.readDouble = function()
	{
		var read;
		if(this.position%Float64Array.BYTES_PER_ELEMENT != 0)
		{
			// data not align :(
			var buffer = new ArrayBuffer(Float64Array.BYTES_PER_ELEMENT); 
			var write = new Uint8Array(buffer);
			for(var i=0;i<write.length;i++)
				write[i] = this.readUInt8();
				
			read = new Float64Array(buffer);
		}
		else
		{
			read = new Float64Array( data, this.position, 1 );
			this.position+= Float64Array.BYTES_PER_ELEMENT;
		}
		return read[0]; 
	};
	
}

 
