/**
 * @author p3ga5e
 */

THREE.Ms3dMaterial = function ( geom, material ) 
{
	
	var matrices = [];
	for(var i=0;i<50;i++)
		matrices.push(new THREE.Matrix4());
		
	THREE.ShaderMaterial.call( this, 
	{
		attributes:   
		{	boneIndices: {	type: 'f', value: geom.boneIndices }
		},
		uniforms: 		
		{
			boneMatrices : { type: "m4v", value: matrices },
			color:     { type: "c", value: material.diffuse },
			texture:   { type: "t", value: 0, texture: material.texture }
		},
		vertexShader:   
		[	"uniform mat4 boneMatrices[50];",
			"attribute float boneIndices;",
			"varying vec2 vUv;",
			
			"void main() {",
			" vUv = uv;",
			" gl_Position = projectionMatrix * modelViewMatrix *  boneMatrices[int(boneIndices)] *  vec4( position, 1.0 );",
			"}"
		].join("\n"), 
		fragmentShader: 
		[	"varying vec2 vUv;",

			"uniform vec3 color;",
			"uniform sampler2D texture;",
			
			"void main() {",
			"	gl_FragColor = vec4( color, 1.0 ) * texture2D( texture, vUv );",
			"}"
		].join("\n"), 
	} );
};

THREE.Ms3dMaterial.prototype = new THREE.ShaderMaterial();
THREE.Ms3dMaterial.prototype.constructor = THREE.Ms3dMaterial;
