/**
 * @author p3ga5e
 */
 THREE.Ms3dMesh = function ( geometry, material ) 
{
	THREE.Mesh.call( this, geometry, new THREE.Ms3dMaterial(geometry,material));
	
	for(var i=0;i<this.geometry.Joints.length;i++)
		this.geometry.Joints[i].updateMatrix();
	
	this.invBonesMatrices = []; 
	this.bonesMatrices = [];
	for(var i=0;i<this.geometry.Joints.length;i++)
	{
		this.material.uniforms.boneMatrices.value[i] = this.geometry.Joints[i].getBoneMatrix();
		this.bonesMatrices.push(this.material.uniforms.boneMatrices.value[i])
		var invmat = new THREE.Matrix4();
		this.invBonesMatrices.push(invmat.getInverse(this.material.uniforms.boneMatrices.value[i]));
	}

	for ( var i = 0, l = this.geometry.vertices.length; i < l; i ++ ) 
	{
		var bidx = this.geometry.boneIndices[i];
		var mat = this.invBonesMatrices[bidx];
		this.geometry.vertices[ i ].position = mat.multiplyVector3(this.geometry.vertices[ i ].position);
	}
	
}

THREE.Ms3dMesh.prototype = new THREE.Mesh();
THREE.Ms3dMesh.prototype.constructor = THREE.Ms3dMesh;
THREE.Ms3dMesh.prototype.supr = THREE.Mesh.prototype;

THREE.Ms3dMesh.prototype.createAnimation = function(config) 
{
	var start = 0, end = this.geometry.metadata.animation.TotalFrames/this.geometry.metadata.animation.fps;
	if(config && config.StartTime)
		start = config.StartTime;
	else if(config && config.StartFrame)
		start = config.StartFrame/this.geometry.metadata.animation.fps;
	
	if(config && config.EndTime)
		end = config.EndTime;
	else if(config && config.EndFrame)
		end = config.EndFrame/this.geometry.metadata.animation.fps;
	
	var anim = new THREE.Ms3dAnimation([start , end], this.geometry.metadata.animation.fps);
	if(config && config.Name)
		anim.Name = config.Name;
	
	if(config && config.Speed)
		anim.Speed = config.Speed;
	
	return anim;
}

THREE.Ms3dMesh.prototype.update = function(time) 
{

	for(var i=0;i<this.geometry.Joints.length;i++)
		this.geometry.Joints[i].updateMatrix(time);
		
	for(var i=0;i<this.geometry.Joints.length;i++)
	{
		this.material.uniforms.boneMatrices.value[i] = this.geometry.Joints[i].getBoneMatrix();
	}
}


